/**** C header file for QAUPIED.DLL v6.85(49) ****/

#ifdef __cplusplus
extern "C" {
#endif


/****************** System Definitions ***************************************/

#define qaerr_FATAL -1000
#define qaerr_NOMEMORY -1001
#define qaerr_INITINSTANCE -1002
#define qaerr_BADINTERFACE -1003
#define qaerr_INITOOLARGE -1005
#define qaerr_ININOEXTEND -1006
#define qaerr_FILETOOLARGE -1008
#define qaerr_FILECHGDETECT -1009
#define qaerr_FILEOPEN -1010
#define qaerr_FILEEXIST -1011
#define qaerr_FILEREAD -1012
#define qaerr_FILEWRITE -1013
#define qaerr_FILEDELETE -1014
#define qaerr_FILEACCESS -1016
#define qaerr_FILEVERSION -1017
#define qaerr_FILEHANDLE -1018
#define qaerr_FILECREATE -1019
#define qaerr_FILERENAME -1020
#define qaerr_FILEEXPIRED -1021
#define qaerr_FILENOTDEMO -1022
#define qaerr_FILETIMEGET -1023
#define qaerr_FILETIMESET -1024
#define qaerr_READFAIL -1025
#define qaerr_WRITEFAIL -1026
#define qaerr_BADDRIVE -1027
#define qaerr_BADDIR -1028
#define qaerr_DIRCREATE -1029
#define qaerr_BADOPTION -1030
#define qaerr_BADINIFILE -1031
#define qaerr_BADLOGFILE -1032
#define qaerr_BADMEMORY -1033
#define qaerr_BADHOTKEY -1034
#define qaerr_HOTKEYUSED -1035
#define qaerr_BADRESOURCE -1036
#define qaerr_BADDATADIR -1037
#define qaerr_BADTEMPDIR -1038
#define qaerr_NOTDEFINED -1040
#define qaerr_DUPLICATE -1041
#define qaerr_BADACTION -1042
#define qaerr_BADDATE -1045
#define qaerr_BADTIMEZONE -1046
#define qaerr_CCFAILURE -1050
#define qaerr_CCBADCODE -1051
#define qaerr_CCACCESS -1052
#define qaerr_CCNODONGLE -1053
#define qaerr_CCNOUNITS -1054
#define qaerr_CCNOMETER -1055
#define qaerr_CCNOFEATURE -1056
#define qaerr_CCINVALID -1057
#define qaerr_CCNODCHKFAIL -1058
#define qaerr_CCINSTALL -1060
#define qaerr_CCEXPIRED -1061
#define qaerr_CCDATETIME -1062
#define qaerr_CCUSERLIMIT -1063
#define qaerr_CCACTIVATE -1064
#define qaerr_CCBADDRIVE -1065
#define qaerr_CCREGISTER -1066
#define qaerr_UNAUTHORISED -1070
#define qaerr_NOLOCALEFILE -1074
#define qaerr_BADLOCALEFILE -1075
#define qaerr_BADLOCALE -1076
#define qaerr_BADCODEPAGE -1077
#define qaerr_RESOURCEFAIL -1078
#define qaerr_NOTHREAD -1080
#define qaerr_NOTLSMEMORY -1081
#define qaerr_NOTASK -1090
#define qaerr_LOADLIBRARY -1091
#define qaerr_API_WORD -1094
#define qaerr_API_DWORD -1095
#define qaerr_CHARSET -1096
#define qaerr_BUFFERTRUNC -1097
#define MAXCONSTRAINWORD 65535
#define MAXCONSTRAINDWORD -1


/****************** API Error codes ******************************************/

#define qaerr_TOOMANYINSTANCES -4501
#define qaerr_MAXRESOURCES -4503
#define qaerr_OPENFAILURE -4551
#define qaerr_APIHANDLE -4552
#define qaerr_OUTOFSEQUENCE -4553
#define qaerr_BUSYHANDLE -4554
#define qaerr_BADINDEX -4556
#define qaerr_BADVALUE -4557
#define qaerr_BADPARAM -4558
#define qaerr_PARAMTRUNCATED -4559
#define qaerr_NOENGINE -4560
#define qaerr_BADLAYOUT -4561
#define qaerr_BADSTEP -4562
#define qaerr_DATASETNOTAVAILABLE -4570
#define qaerr_LICENSINGFAILURE -4571
#define qaerr_NOACTIVEDATASET -4572
#define qaerr_BADCOUNTRYLIST -4573
#define qaerr_DATAMAPNOTAVAILABLE -4574
#define qaerr_NOCOUNTRYFOUND -4575
#define qaerr_SERVERCONNLOST -4580
#define qaerr_SERVERFULL -4581
#define qaerr_BADMONIKER -4590
#define qaerr_MONIKEREXPIRED -4591


/****************** API Definitions ******************************************/

/* Invalid handle */
#define NO_HANDLE 0

/* QA_SetLibraryFlags () flags */
#define qalibflags_NONE 0

/* Boolean values */
#define qavalue_FALSE 0
#define qavalue_TRUE 1

/* QA_SetEngine () and QA_GetEngine () types */
#define qaengine_SINGLELINE 1
#define qaengine_TYPEDOWN 2
#define qaengine_BATCH 3
#define qaengine_VERIFICATION 4
#define qaengine_KEYFINDER 5

/* Engine option types */
#define qaengopt_DEFAULT 0
#define qaengopt_ASYNCSEARCH 1
#define qaengopt_ASYNCSTEPIN 2
#define qaengopt_ASYNCREFINE 3
#define qaengopt_THRESHOLD 6
#define qaengopt_TIMEOUT 7
#define qaengopt_SEARCHINTENSITY 8

/* Engine option search intensity */
#define qaintensity_EXACT 0
#define qaintensity_CLOSE 1
#define qaintensity_EXTENSIVE 2

/* GetSearchStatus () state flags */
#define qastate_NOSEARCH 1
#define qastate_STILLSEARCHING 2
#define qastate_TIMEOUT 4
#define qastate_SEARCHCANCELLED 8
#define qastate_MAXMATCHES 16
#define qastate_OVERTHRESHOLD 32
#define qastate_LARGEPOTENTIAL 64
#define qastate_MOREOTHERMATCHES 128
#define qastate_REFINING 256
#define qastate_AUTOSTEPINSAFE 512
#define qastate_AUTOSTEPINPASTCLOSE 1024
#define qastate_CANSTEPOUT 2048
#define qastate_AUTOFORMATSAFE 4096
#define qastate_AUTOFORMATPASTCLOSE 8192

/* GetSearchStatusDetail () types */
#define qassint_PICKLISTSIZE 1
#define qassint_POTENTIALMATCHES 2
#define qassint_SEARCHSTATE 3
#define qassint_ISNOSEARCH 4
#define qassint_ISSTILLSEARCHING 5
#define qassint_ISTIMEOUT 6
#define qassint_ISSEARCHCANCELLED 7
#define qassint_ISMAXMATCHES 8
#define qassint_ISOVERTHRESHOLD 9
#define qassint_ISLARGEPOTENTIAL 10
#define qassint_ISMOREOTHERMATCHES 11
#define qassint_ISREFINING 12
#define qassint_ISAUTOSTEPINSAFE 17
#define qassint_ISAUTOSTEPINPASTCLOSE 18
#define qassint_CANSTEPOUT 19
#define qassint_ISAUTOFORMATSAFE 20
#define qassint_ISAUTOFORMATPASTCLOSE 21

/* QA_GetResult () flags */
#define qaresult_FULLADDRESS 1
#define qaresult_MULTIPLES 2
#define qaresult_CANSTEP 4
#define qaresult_ALIASMATCH 8
#define qaresult_POSTCODERECODED 16
#define qaresult_CROSSBORDERMATCH 32
#define qaresult_DUMMYPOBOX 64
#define qaresult_NAME 256
#define qaresult_INFORMATION 1024
#define qaresult_WARNINFORMATION 2048
#define qaresult_INCOMPLETEADDR 4096
#define qaresult_UNRESOLVABLERANGE 8192
#define qaresult_INCLUDESUSERDATA 16384
#define qaresult_PHANTOMPRIMARYPOINT 32768
#define qaresult_RESOLVEDPPP 65536
#define qaresult_POSTCODESUBSTITUTE 131072

/* QA_GetResultDetail () types */
#define qaresultstr_DATAID 1
#define qaresultstr_DESCRIPTION 2
#define qaresultstr_PARTIALADDRESS 3
#define qaresultstr_MATCHTYPE 5
#define qaresultint_CONFIDENCE 6
#define qaresultint_UNUSEDLINES 7
#define qaresultint_POSTCODEACTION 8
#define qaresultint_ADDRESSACTION 9
#define qaresultint_GENERICINFO 10
#define qaresultint_COUNTRYINFO1 11
#define qaresultint_COUNTRYINFO2 12
#define qaresultint_ISFULLADDRESS 13
#define qaresultint_ISMULTIPLES 14
#define qaresultint_ISCANSTEP 15
#define qaresultint_ISALIASMATCH 16
#define qaresultint_ISPOSTCODERECODED 17
#define qaresultint_ISCROSSBORDERMATCH 18
#define qaresultint_ISDUMMYPOBOX 19
#define qaresultint_ISNAME 20
#define qaresultint_ISINFORMATION 21
#define qaresultint_ISWARNINFORMATION 22
#define qaresultint_ISINCOMPLETEADDR 23
#define qaresultint_ISUNRESOLVABLERANGE 24
#define qaresultint_ISINCLUDEUSERDATA 25
#define qaresultstr_ADDRMATCHCODE 26
#define qaresultstr_POSTCODEMATCHED 27
#define qaresultint_ISPHANTOMPRIMARYPOINT 28
#define qaresultint_POSTCODESUBS 29

/* QA_GetPromptStatus () types */
#define qapromptint_LINECOUNT 1
#define qapromptint_DYNAMIC 2

/* QA_GetDataDetail () types */
#define qadatastr_ID 1
#define qadatastr_DESCRIPTION 2
#define qadatastr_BASE 3
#define qadatastr_DATASETS 4

/* QA_GetLicensingCount () and QA_GetLicensingDetail () warning levels */
#define qalicwarn_NONE 0
#define qalicwarn_DATAEXPIRING 10
#define qalicwarn_LICENCEEXPIRING 20
#define qalicwarn_CLICKSLOW 25
#define qalicwarn_EVALUATION 30
#define qalicwarn_NOCLICKS 35
#define qalicwarn_DATAEXPIRED 40
#define qalicwarn_EVALLICENCEEXPIRED 50
#define qalicwarn_FULLLICENCEEXPIRED 60
#define qalicwarn_LICENCENOTFOUND 70
#define qalicwarn_DATAUNREADABLE 80
#define qalicwarn_INVALIDSUBSET 90

/* QA_GetLicensingDetail () types */
#define qalicencestr_ID 1
#define qalicencestr_DESCRIPTION 2
#define qalicencestr_COPYRIGHT 3
#define qalicencestr_VERSION 4
#define qalicencestr_BASECOUNTRY 5
#define qalicencestr_STATUS 6
#define qalicencestr_SERVER 7
#define qalicenceint_WARNINGLEVEL 8
#define qalicenceint_DAYSLEFT 9
#define qalicenceint_DATADAYSLEFT 10
#define qalicenceint_LICENCEDAYSLEFT 11

/* QA_CancelSearch () flags */
#define qacancelflag_NONE 0
#define qacancelflag_BLOCKING 1

/* QA_FormatResult () and QA_FormatExample () flags */
#define qaformat_OVERFLOW 1
#define qaformat_TRUNCATED 2
#define qaformat_DPVVALID 16
#define qaformat_DPVINVALID 32
#define qaformat_DPVLOCKED 64

/* QA_GetFormattedLine () flags */
#define qaformatted_NONE 0
#define qaformatted_NAME 1
#define qaformatted_ADDRESS 2
#define qaformatted_ANCILLARY 4
#define qaformatted_DATAPLUS 8
#define qaformatted_TRUNCATED 16
#define qaformatted_OVERFLOW 32
#define qaformatted_DATAPLUSSYNTAX 64
#define qaformatted_DATAPLUSEXPIRED 128
#define qaformatted_DATAPLUSBLANK 256
#define qaformatted_UNMATCHED 512

/* QA_GenerateSystemInfo () types */
#define qasysinfo_SYSTEM 1

/* QA_GetUnusedInput () types */
#define qaunusedstr_TEXT 1
#define qaunusedint_COMPLETENESS 2
#define qaunusedint_TYPE 3
#define qaunusedint_POSITION 4
#define qaunusedint_ISCAREOF 5
#define qaunusedint_ISPREMSUFFIX 6



/****************** API Function prototypes **********************************/

__declspec(dllimport) int __stdcall QA_SetLibraryFlags(long);
__declspec(dllimport) int __stdcall QA_Open(char *, char *, int *);
__declspec(dllimport) int __stdcall QA_Close(int);
__declspec(dllimport) void __stdcall QA_Shutdown(void);
__declspec(dllimport) int __stdcall QA_SetEngine(int, int);
__declspec(dllimport) int __stdcall QA_GetEngine(int, int *);
__declspec(dllimport) int __stdcall QA_SetEngineOption(int, int, long);
__declspec(dllimport) int __stdcall QA_GetEngineOption(int, int, long *);
__declspec(dllimport) int __stdcall QA_GetEngineStatus(int, int, int *);
__declspec(dllimport) int __stdcall QA_GetPromptStatus(int, int, int *, char *, int);
__declspec(dllimport) int __stdcall QA_GetPrompt(int, int, char *, int, int *, char *, int);
__declspec(dllimport) int __stdcall QA_Search(int, char *);
__declspec(dllimport) int __stdcall QA_CancelSearch(int, long);
__declspec(dllimport) int __stdcall QA_EndSearch(int);
__declspec(dllimport) int __stdcall QA_GetSearchStatus(int, int *, int *, long *);
__declspec(dllimport) int __stdcall QA_GetSearchStatusDetail(int, int, long *, char *, int);
__declspec(dllimport) int __stdcall QA_StepIn(int, int);
__declspec(dllimport) int __stdcall QA_StepOut(int);
__declspec(dllimport) int __stdcall QA_GetResult(int, int, char *, int, int *, long *);
__declspec(dllimport) int __stdcall QA_GetResultDetail(int, int, int, long *, char *, int);
__declspec(dllimport) int __stdcall QA_FormatResult(int, int, char *, int *, long *);
__declspec(dllimport) int __stdcall QA_GetFormattedLine(int, int, char *, int, char *, int, long *);
__declspec(dllimport) int __stdcall QA_GetExampleCount(int, int *);
__declspec(dllimport) int __stdcall QA_FormatExample(int, int, char *, int, int *, long *);
__declspec(dllimport) int __stdcall QA_GetLayoutCount(int, int *);
__declspec(dllimport) int __stdcall QA_GetLayout(int, int, char *, int, char *, int);
__declspec(dllimport) int __stdcall QA_GetActiveLayout(int, char *, int);
__declspec(dllimport) int __stdcall QA_SetActiveLayout(int, char *);
__declspec(dllimport) int __stdcall QA_GetDataCount(int, int *);
__declspec(dllimport) int __stdcall QA_GetData(int, int, char *, int, char *, int);
__declspec(dllimport) int __stdcall QA_GetDataDetail(int, int, int, long *, char *, int);
__declspec(dllimport) int __stdcall QA_GetLicensingCount(int, int *, long *);
__declspec(dllimport) int __stdcall QA_GetLicensingDetail(int, int, int, long *, char *, int);
__declspec(dllimport) int __stdcall QA_GetActiveData(int, char *, int);
__declspec(dllimport) int __stdcall QA_SetActiveData(int, char *);
__declspec(dllimport) int __stdcall QA_GenerateSystemInfo(int, int, int *);
__declspec(dllimport) int __stdcall QA_GetSystemInfo(int, int, char *, int);
__declspec(dllimport) int __stdcall QA_ErrorMessage(int, char *, int);

/* Utility function prototypes */
__declspec(dllimport) long __stdcall QA_IsFlagSet(long, long);

#ifdef __cplusplus
}
#endif

/**** End of File ****/
