/******************************************************************************
*
* File  :   qs_ui.c
* Desc  :   Test harness for the QAS Pro World Version User Interface API
*   (c) QAS Ltd
*
******************************************************************************/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "qauwved.h"

#define BUFFLEN 256

int main(int iArgC, char *papsArgV[])
{
    int iCode;
    int i, iResults;
    char sTitle[BUFFLEN];
    char sIniFile[BUFFLEN];
    char sLayout[BUFFLEN];
    char sCountry[BUFFLEN];
    char sSearch[BUFFLEN];
    char sResult[BUFFLEN];
    long lFlags;
    

	/* Initialise the variables */
    strcpy(sTitle,"QAS Pro UI API Test Harness");
    strcpy(sIniFile,"");
    strcpy(sLayout,"");
    strcpy(sSearch,"");
    strcpy(sCountry,"");
    lFlags = qaattribs_NONE;

    /* Start up */
    if ((iCode = QAProWV_UIStartup(  sTitle,
                                     sIniFile,
                                     sCountry,
                                     sLayout,
                                     NULL,
                                     lFlags)) == 0)
    {
        /* Call search until dialog is closed without searching */
        while ((iCode = QAProWV_UISearch(sSearch)) > 0)
        {
            iCode = QAProWV_UIResultCount(&iResults);

            /* Display the resulting address lines on the console window */
            for(i = 0; iCode == 0 && i < iResults ; i++)
            {
                iCode = QAProWV_UIGetResult(i,
                            sResult,
                            BUFFLEN);

                printf("%s\n", sResult);
            }
            printf("\n\n");
        }
    }

    /* Finish with the API */
    QAProWV_UIShutdown(iCode);

    return iCode;
}

/* End of qs_ui.c */
